
CoCoA-5 - Bug #1420

IdealOfProjectivePoints and MinGens: problem with CoCoA_ASSERT

18 Feb 2020 12:19 - John Abbott

Status: Closed Start date: 18 Feb 2020

Priority: High Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: bug Estimated time: 1.50 hour

Target version: CoCoA-5.3.0 Spent time: 1.45 hour

Description

I compiled CoCoALib (and CoCoA-5) with debugging active.  The last test in exbug.cocoa5 fails

use P ::= QQ[x,y,z];

K := IdealOfProjectivePoints(P,mat([[0,1,1],[0,0,1]]));

MinGens(K);

 

The problem is a failed assertion:

==== CoCoA Assertion failed: [[myGBasisValue.empty()]]

==== File: SparsePolyOps-ideal.C

==== Line: 737

Related issues:

Related to CoCoALib - Bug #1416: IdealOfProjectivePoints and MinGens Closed 14 Feb 2020

Related to CoCoALib - Design #1422: Remove flag IhaveGBasisValue? In Progress 25 Feb 2020

History

#1 - 18 Feb 2020 12:20 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

The problem is in the fn myGBasis

The impl has too many assertions that myGBasis is empty; just a single assertion (in the right place) should suffice!

The code looks dodgy to me...

#2 - 18 Feb 2020 13:37 - John Abbott

- Description updated

#3 - 25 Feb 2020 15:48 - Anna Maria Bigatti

- Related to Bug #1416: IdealOfProjectivePoints and MinGens added

#4 - 25 Feb 2020 15:52 - Anna Maria Bigatti

- Related to Design #924: FlagManager for bool/bool3 flags added

#5 - 25 Feb 2020 16:07 - Anna Maria Bigatti

- Subject changed from IdealOfProjectivePoints to IdealOfProjectivePoints and MinGens: problem with CoCoA_ASSERT
- Status changed from In Progress to Resolved

- Assignee set to Anna Maria Bigatti

- Priority changed from Urgent to High

- % Done changed from 10 to 50

#6 - 25 Feb 2020 16:16 - Anna Maria Bigatti

- Related to Design #1422: Remove flag IhaveGBasisValue? added

#7 - 25 Feb 2020 16:16 - Anna Maria Bigatti

- Related to deleted (Design #924: FlagManager for bool/bool3 flags)

#8 - 25 Feb 2020 16:24 - Anna Maria Bigatti

- Target version changed from CoCoA-5.3.0 to CoCoA-5.4.0

This problems comes from the fact that IdealOfProjectivePoints computes a GBasis, without determining the minimal generators.

The function MinGens, then has to run myGBasis, with Buchberger Algorithm, to find the minimal generators, effectively forgetting that the ideal

already has a GBasis.

The quick&easy solution to #1416 was to set IhaveGBasisValue = false; to force the call.

But now the assert complains the assert in myGBasis (only when debugging is on) finds the mismatch.

Deciding and solving #1422 will solve this issue too.

#9 - 26 Feb 2020 16:31 - Anna Maria Bigatti

- Status changed from Resolved to Closed

- Target version changed from CoCoA-5.4.0 to CoCoA-5.3.0

commented out ASSERT.

This may be closed, leaving Design #1422 to do for next release.

#10 - 26 Feb 2020 16:59 - John Abbott

- % Done changed from 50 to 100

- Estimated time set to 1.50 h
